/** ascUtils.h - Routines and data structures for reading and writing
 * alt spliced catalog. */

/** This structure holds info on one entry of alt-splicing catalog. */
struct altSpec
    {
    struct altSpec *next;
    char *hrefTag;
    char *orfName;
    boolean skipExon, skipIntron, nonGenomic;
    int alt3, alt5;
    int ieOverlap, iiOverlap;
    struct slName *cdna;
    boolean hasNewCdna;
    boolean isInOld;
    };

/** Read alt-splicing file and turn it into an altSpec list. */
struct altSpec *readAlts(char *fileName, boolean oldStyle);

void writeAlts(char *fileName, struct altSpec *altList, 
    boolean newOnly, boolean notOldOnly);
/** Write alt-splicing file. */

/** Remove HrefTag from line and return it. */
char *eatHrefTag(char *line);

