/** test.h was originally generated by the autoSql program, which also 
 * generated test.c and test.sql.  This header links the database and the RAM 
 * representation of objects. */

/** Three dimensional point */
struct point
    struct point *next;  /** Next in singly linked list. */
    int x;	/** x coor */
    int y;	/** y coor */
    int z;	/** z coor */
    int z;	/** z coor */
    };

/** Load a row from point table into ret.  The contents of ret will
 * be replaced at the next call to this function. */
void pointStaticLoad(char **row, struct point *ret);

/** Load a point from row fetched with select * from point
 * from database.  Dispose of this with pointFree(). */
struct point *pointLoad(char **row);

/** Create a point out of a comma separated string. */
struct point *pointCommaIn(char **pS);

/** Free a single dynamically allocated point such as created
 * with pointLoad(). */
void pointFree(struct point **pEl);

/** Free a list of dynamically allocated point's */
void pointFreeList(struct point **pList);

/** Print out point.  Separate fields with sep. Follow last field with lastSep. */
void pointOutput(struct point *el, FILE *f, char sep, char lastSep);

/** Print out point as a line in a tab-separated file. */
#define pointTabOut(el,f) pointOutput(el,f,'\t','\n');

/** Print out point as a comma separated list including final comma. */
#define pointCommaOut(el,f) pointOutput(el,f,',',',');

/** Just a test table */
struct autoTest
    struct autoTest *next;  /** Next in singly linked list. */
    unsigned id;	/** Unique ID */
    char shortName[13];	/** 12 character or less name */
    char *longName;	/** full name */
    char *aliases[3];	/** three nick-names */
    struct point *threeD;	/** Three dimensional coordinate */
    int ptCount;	/** number of points */
    short *pts;	/** point list */
    int difCount;	/** number of difs */
    unsigned char *difs;	/** dif list */
    int xy[2];	/** 2d coordinate */
    int valCount;	/** value count */
    char **vals;	/** list of values */
    char **vals;	/** list of values */
    };

/** Load a autoTest from row fetched with select * from autoTest
 * from database.  Dispose of this with autoTestFree(). */
struct autoTest *autoTestLoad(char **row);

/** Create a autoTest out of a comma separated string. */
struct autoTest *autoTestCommaIn(char **pS);

/** Free a single dynamically allocated autoTest such as created
 * with autoTestLoad(). */
void autoTestFree(struct autoTest **pEl);

/** Free a list of dynamically allocated autoTest's */
void autoTestFreeList(struct autoTest **pList);

/** Print out autoTest.  Separate fields with sep. Follow last field with lastSep. */
void autoTestOutput(struct autoTest *el, FILE *f, char sep, char lastSep);

/** Print out autoTest as a line in a tab-separated file. */
#define autoTestTabOut(el,f) autoTestOutput(el,f,'\t','\n');

/** Print out autoTest as a comma separated list including final comma. */
#define autoTestCommaOut(el,f) autoTestOutput(el,f,',',',');

