/** test.h was originally generated by the autoSql program, which also 
 * generated test.c and test.sql.  This header links the database and
 * the RAM representation of objects. */

#ifndef TEST_H
#define TEST_H

/** Two dimensional point */
struct pt
    int x;	/** x coor */
    int y;	/** y coor */
    int y;	/** y coor */
    };

/** Create a pt out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new pt */
struct pt *ptCommaIn(char **pS, struct pt *ret);

/** Print out pt.  Separate fields with sep. Follow last field with lastSep. */
void ptOutput(struct pt *el, FILE *f, char sep, char lastSep);

/** Print out pt as a line in a tab-separated file. */
#define ptTabOut(el,f) ptOutput(el,f,'\t','\n');

/** Print out pt as a comma separated list including final comma. */
#define ptCommaOut(el,f) ptOutput(el,f,',',',');

/** Three dimensional point */
struct point
    struct point *next;  /** Next in singly linked list. */
    char acc[13];	/** GenBank Accession sequence */
    int x;	/** x coor */
    int y;	/** y coor */
    int z;	/** z coor */
    struct pt pt;	/** Transformed point. */
    struct pt pt;	/** Transformed point. */
    };

/** Create a point out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new point */
struct point *pointCommaIn(char **pS, struct point *ret);

/** Free a single dynamically allocated point such as created
 * with pointLoad(). */
void pointFree(struct point **pEl);

/** Free a list of dynamically allocated point's */
void pointFreeList(struct point **pList);

/** Print out point.  Separate fields with sep. Follow last field with lastSep. */
void pointOutput(struct point *el, FILE *f, char sep, char lastSep);

/** Print out point as a line in a tab-separated file. */
#define pointTabOut(el,f) pointOutput(el,f,'\t','\n');

/** Print out point as a comma separated list including final comma. */
#define pointCommaOut(el,f) pointOutput(el,f,',',',');

/** A face */
struct polygon
    struct polygon *next;  /** Next in singly linked list. */
    unsigned id;	/** Unique ID */
    int pointCount;	/** point count */
    struct point *points;	/** Points list */
    struct pt *persp;	/** Points after perspective transformation */
    struct pt *persp;	/** Points after perspective transformation */
    };

/** Load a polygon from row fetched with select * from polygon
 * from database.  Dispose of this with polygonFree(). */
struct polygon *polygonLoad(char **row);

/** Load all polygon from a tab-separated file.
 * Dispose of this with polygonFreeList(). */
struct polygon *polygonLoadAll(char *fileName);

/** Create a polygon out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new polygon */
struct polygon *polygonCommaIn(char **pS, struct polygon *ret);

/** Free a single dynamically allocated polygon such as created
 * with polygonLoad(). */
void polygonFree(struct polygon **pEl);

/** Free a list of dynamically allocated polygon's */
void polygonFreeList(struct polygon **pList);

/** Print out polygon.  Separate fields with sep. Follow last field with lastSep. */
void polygonOutput(struct polygon *el, FILE *f, char sep, char lastSep);

/** Print out polygon as a line in a tab-separated file. */
#define polygonTabOut(el,f) polygonOutput(el,f,'\t','\n');

/** Print out polygon as a comma separated list including final comma. */
#define polygonCommaOut(el,f) polygonOutput(el,f,',',',');

/** A 3-d object */
struct polyhedron
    struct polyhedron *next;  /** Next in singly linked list. */
    unsigned id;	/** Unique ID */
    char *names[2];	/** Name of this figure */
    int polygonCount;	/** Polygon count */
    struct polygon *polygons;	/** Polygons */
    struct pt screenBox[2];	/** Bounding box in screen coordinates */
    struct pt screenBox[2];	/** Bounding box in screen coordinates */
    };

/** Load a polyhedron from row fetched with select * from polyhedron
 * from database.  Dispose of this with polyhedronFree(). */
struct polyhedron *polyhedronLoad(char **row);

/** Load all polyhedron from a tab-separated file.
 * Dispose of this with polyhedronFreeList(). */
struct polyhedron *polyhedronLoadAll(char *fileName);

/** Create a polyhedron out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new polyhedron */
struct polyhedron *polyhedronCommaIn(char **pS, struct polyhedron *ret);

/** Free a single dynamically allocated polyhedron such as created
 * with polyhedronLoad(). */
void polyhedronFree(struct polyhedron **pEl);

/** Free a list of dynamically allocated polyhedron's */
void polyhedronFreeList(struct polyhedron **pList);

/** Print out polyhedron.  Separate fields with sep. Follow last field with lastSep. */
void polyhedronOutput(struct polyhedron *el, FILE *f, char sep, char lastSep);

/** Print out polyhedron as a line in a tab-separated file. */
#define polyhedronTabOut(el,f) polyhedronOutput(el,f,'\t','\n');

/** Print out polyhedron as a comma separated list including final comma. */
#define polyhedronCommaOut(el,f) polyhedronOutput(el,f,',',',');

/** Two points back to back */
struct twoPoint
    char name[13];	/** name of points */
    struct pt a;	/** point a */
    struct pt b;	/** point b */
    struct pt points[2];	/** points as array */
    struct pt points[2];	/** points as array */
    };

/** Create a twoPoint out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new twoPoint */
struct twoPoint *twoPointCommaIn(char **pS, struct twoPoint *ret);

/** Print out twoPoint.  Separate fields with sep. Follow last field with lastSep. */
void twoPointOutput(struct twoPoint *el, FILE *f, char sep, char lastSep);

/** Print out twoPoint as a line in a tab-separated file. */
#define twoPointTabOut(el,f) twoPointOutput(el,f,'\t','\n');

/** Print out twoPoint as a comma separated list including final comma. */
#define twoPointCommaOut(el,f) twoPointOutput(el,f,',',',');

/** An array of strings */
struct stringArray
    struct stringArray *next;  /** Next in singly linked list. */
    int numNames;	/** Number of names */
    char **names;	/** Array of names */
    char **names;	/** Array of names */
    };

/** Load a stringArray from row fetched with select * from stringArray
 * from database.  Dispose of this with stringArrayFree(). */
struct stringArray *stringArrayLoad(char **row);

/** Load all stringArray from a tab-separated file.
 * Dispose of this with stringArrayFreeList(). */
struct stringArray *stringArrayLoadAll(char *fileName);

/** Create a stringArray out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new stringArray */
struct stringArray *stringArrayCommaIn(char **pS, struct stringArray *ret);

/** Free a single dynamically allocated stringArray such as created
 * with stringArrayLoad(). */
void stringArrayFree(struct stringArray **pEl);

/** Free a list of dynamically allocated stringArray's */
void stringArrayFreeList(struct stringArray **pList);

/** Print out stringArray.  Separate fields with sep. Follow last field with lastSep. */
void stringArrayOutput(struct stringArray *el, FILE *f, char sep, char lastSep);

/** Print out stringArray as a line in a tab-separated file. */
#define stringArrayTabOut(el,f) stringArrayOutput(el,f,'\t','\n');

/** Print out stringArray as a comma separated list including final comma. */
#define stringArrayCommaOut(el,f) stringArrayOutput(el,f,',',',');

#endif /** TEST_H */

