/** agpFrag.h was originally generated by the autoSql program, which also 
 * generated agpFrag.c and agpFrag.sql.  This header links the database and the RAM 
 * representation of objects. */

#ifndef AGPFRAG_H
#define AGPFRAG_H

/** How to get through chromosome based on fragments */
struct agpFrag
    struct agpFrag *next;  /** Next in singly linked list. */
    char *chrom;	/** which chromosome */
    unsigned chromStart;	/** start position in chromosome */
    unsigned chromEnd;	/** end position in chromosome */
    int ix;	/** ix of this fragment (useless) */
    char type[2];	/** (P)redraft, (D)raft, (F)inished or (O)ther */
    char *frag;	/** which fragment */
    unsigned fragStart;	/** start position in frag */
    unsigned fragEnd;	/** end position in frag */
    char strand[2];	/** + or - (orientation of fragment) */
    char strand[2];	/** + or - (orientation of fragment) */
    };

/** Load a row from agpFrag table into ret.  The contents of ret will
 * be replaced at the next call to this function. */
void agpFragStaticLoad(char **row, struct agpFrag *ret);

/** Load a agpFrag from row fetched with select * from agpFrag
 * from database.  Dispose of this with agpFragFree(). */
struct agpFrag *agpFragLoad(char **row);

/** Create a agpFrag out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new agpFrag */
struct agpFrag *agpFragCommaIn(char **pS, struct agpFrag *ret);

/** Free a single dynamically allocated agpFrag such as created
 * with agpFragLoad(). */
void agpFragFree(struct agpFrag **pEl);

/** Free a list of dynamically allocated agpFrag's */
void agpFragFreeList(struct agpFrag **pList);

/** Print out agpFrag.  Separate fields with sep. Follow last field with lastSep. */
void agpFragOutput(struct agpFrag *el, FILE *f, char sep, char lastSep);

/** Print out agpFrag as a line in a tab-separated file. */
#define agpFragTabOut(el,f) agpFragOutput(el,f,'\t','\n');

/** Print out agpFrag as a comma separated list including final comma. */
#define agpFragCommaOut(el,f) agpFragOutput(el,f,',',',');

#endif /** AGPFRAG_H */

