/** clonePos.h was originally generated by the autoSql program, which also 
 * generated clonePos.c and clonePos.sql.  This header links the database and the RAM 
 * representation of objects. */

#ifndef CLONEPOS_H
#define CLONEPOS_H

/** A clone's position and other info. */
struct clonePos
    struct clonePos *next;  /** Next in singly linked list. */
    char *name;	/** Name of clone including version. */
    unsigned seqSize;	/** base count not including gaps */
    unsigned char phase;	/** htg phase */
    char *chrom;	/** Chromosome name */
    unsigned chromStart;	/** Start in chromosome */
    unsigned chromEnd;	/** End in chromosome */
    char stage[2];	/** F/D/P for finished/draft/predraft */
    char *faFile;	/** File with sequence. */
    char *faFile;	/** File with sequence. */
    };

/** Load a row from clonePos table into ret.  The contents of ret will
 * be replaced at the next call to this function. */
void clonePosStaticLoad(char **row, struct clonePos *ret);

/** Load a clonePos from row fetched with select * from clonePos
 * from database.  Dispose of this with clonePosFree(). */
struct clonePos *clonePosLoad(char **row);

/** Create a clonePos out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new clonePos */
struct clonePos *clonePosCommaIn(char **pS, struct clonePos *ret);

/** Free a single dynamically allocated clonePos such as created
 * with clonePosLoad(). */
void clonePosFree(struct clonePos **pEl);

/** Free a list of dynamically allocated clonePos's */
void clonePosFreeList(struct clonePos **pList);

/** Print out clonePos.  Separate fields with sep. Follow last field with lastSep. */
void clonePosOutput(struct clonePos *el, FILE *f, char sep, char lastSep);

/** Print out clonePos as a line in a tab-separated file. */
#define clonePosTabOut(el,f) clonePosOutput(el,f,'\t','\n');

/** Print out clonePos as a comma separated list including final comma. */
#define clonePosCommaOut(el,f) clonePosOutput(el,f,',',',');

#endif /** CLONEPOS_H */

