/** ctgPos.h was originally generated by the autoSql program, which also 
 * generated ctgPos.c and ctgPos.sql.  This header links the database and the RAM 
 * representation of objects. */

#ifndef CTGPOS_H
#define CTGPOS_H

/** Where a contig is inside of a chromosome. */
struct ctgPos
    struct ctgPos *next;  /** Next in singly linked list. */
    char *contig;	/** Name of contig */
    unsigned size;	/** Size of contig */
    char *chrom;	/** Chromosome name */
    unsigned chromStart;	/** Start in chromosome */
    unsigned chromEnd;	/** End in chromosome */
    unsigned chromEnd;	/** End in chromosome */
    };

/** Load a row from ctgPos table into ret.  The contents of ret will
 * be replaced at the next call to this function. */
void ctgPosStaticLoad(char **row, struct ctgPos *ret);

/** Load a ctgPos from row fetched with select * from ctgPos
 * from database.  Dispose of this with ctgPosFree(). */
struct ctgPos *ctgPosLoad(char **row);

/** Create a ctgPos out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new ctgPos */
struct ctgPos *ctgPosCommaIn(char **pS, struct ctgPos *ret);

/** Free a single dynamically allocated ctgPos such as created
 * with ctgPosLoad(). */
void ctgPosFree(struct ctgPos **pEl);

/** Free a list of dynamically allocated ctgPos's */
void ctgPosFreeList(struct ctgPos **pList);

/** Print out ctgPos.  Separate fields with sep. Follow last field with lastSep. */
void ctgPosOutput(struct ctgPos *el, FILE *f, char sep, char lastSep);

/** Print out ctgPos as a line in a tab-separated file. */
#define ctgPosTabOut(el,f) ctgPosOutput(el,f,'\t','\n');

/** Print out ctgPos as a comma separated list including final comma. */
#define ctgPosCommaOut(el,f) ctgPosOutput(el,f,',',',');

#endif /** CTGPOS_H */

