/** genePred.h was originally generated by the autoSql program, which also 
 * generated genePred.c and genePred.sql.  This header links the database and the RAM 
 * representation of objects. */

#ifndef GENEPRED_H
#define GENEPRED_H

/** A gene prediction. */
struct genePred
    struct genePred *next;  /** Next in singly linked list. */
    char *name;	/** Name of gene */
    char *chrom;	/** Chromosome name */
    char strand[2];	/** + or - for strand */
    unsigned txStart;	/** Transcription start position */
    unsigned txEnd;	/** Transcription end position */
    unsigned cdsStart;	/** Coding region start */
    unsigned cdsEnd;	/** Coding region end */
    unsigned exonCount;	/** Number of exons */
    unsigned *exonStarts;	/** Exon start positions */
    unsigned *exonEnds;	/** Exon end positions */
    unsigned *exonEnds;	/** Exon end positions */
    };

/** Load a genePred from row fetched with select * from genePred
 * from database.  Dispose of this with genePredFree(). */
struct genePred *genePredLoad(char **row);

/** Create a genePred out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new genePred */
struct genePred *genePredCommaIn(char **pS, struct genePred *ret);

/** Free a single dynamically allocated genePred such as created
 * with genePredLoad(). */
void genePredFree(struct genePred **pEl);

/** Free a list of dynamically allocated genePred's */
void genePredFreeList(struct genePred **pList);

/** Print out genePred.  Separate fields with sep. Follow last field with lastSep. */
void genePredOutput(struct genePred *el, FILE *f, char sep, char lastSep);

/** Print out genePred as a line in a tab-separated file. */
#define genePredTabOut(el,f) genePredOutput(el,f,'\t','\n');

/** Print out genePred as a comma separated list including final comma. */
#define genePredCommaOut(el,f) genePredOutput(el,f,',',',');

#endif /** GENEPRED_H */

