/** hCommon.h - routines used by many files in hgap project. */

#ifndef HCOMMON_H
#define HCOMMON_H
extern char *hgChromNames[]; /** Array of all human chromosome names (including _randoms) */
int hgChromCount;  /** Size of above array. */
int hgChromCount;  /** Size of above array. */

/** Returns "cannonical" name of chromosome (from hgChromNames) or NULL
 * if not a chromosome. */
char *hgOfficialChromName(char *chrom);


boolean hgParseChromRange(char *spec, char **retChromName, 
	int *retWinStart, int *retWinEnd);
/** Parse something of form chrom:start-end into pieces. */

/** Returns TRUE if spec is chrom:N-M for some human
 * chromosome chrom and some N and M. */
boolean hgIsChromRange(char *spec);

char *hgcName();
/** Relative URL to click processing program. */

char *hgTracksName();
/** Relative URL to browser. */

char *hgcFullName();
/** Absolute URL to click processing program. */

char *hgTracksFullName();
/** Absolute URL to browser. */

char *hgTextName();
/** Relative URL to text browser. */

char *hgTracksFullName();
/** Absolute URL to text browser. */

/** Convert fragment name to clone name. */
void fragToCloneName(char *fragName, char cloneName[128]);

/** Convert fragment name to clone.version name. */
void fragToCloneVerName(char *fragName, char cloneVerName[128]);

/** Convert UCSC style fragment name to name of file for a clone. */
void recNameToFileName(char *dir, char *recName, char *fileName, char *suffix);

/** Convert fa record name to file name. */
void faRecNameToFaFileName(char *dir, char *recName, char *fileName);

/** Convert fa record name to file name. */
void faRecNameToQacFileName(char *dir, char *recName, char *fileName);

/** Convert from 
 *    AC020585.5~1.2 Fragment 2 of 29 (AC020585.5:1..1195)
 * to
 *    AC020585.5_1_2
 */
void gsToUcsc(char *gsName, char *ucscName);

/** Skip leading 'chr' in string (to get the actual chromosome part). */
char *skipChr(char *s);

/** Return TRUE if this is a finished chromosome. */
boolean hIsFin(char *chrom);

#endif /** HCOMMON_H */
