/** refLink.h was originally generated by the autoSql program, which also 
 * generated refLink.c and refLink.sql.  This header links the database and
 * the RAM representation of objects. */

#ifndef REFLINK_H
#define REFLINK_H

/** Link together a refseq mRNA and other stuff */
struct refLink
    struct refLink *next;  /** Next in singly linked list. */
    char *name;	/** Name displayed in UI */
    char *product;	/** Name of protein product */
    char *mrnaAcc;	/** mRNA accession */
    char *protAcc;	/** protein accession */
    unsigned geneId;	/** pointer to geneName table */
    unsigned prodId;	/** pointer to prodName table */
    unsigned locusLinkId;	/** Locus Link ID */
    unsigned omimId;	/** OMIM ID */
    unsigned omimId;	/** OMIM ID */
    };

/** Load a row from refLink table into ret.  The contents of ret will
 * be replaced at the next call to this function. */
void refLinkStaticLoad(char **row, struct refLink *ret);

/** Load a refLink from row fetched with select * from refLink
 * from database.  Dispose of this with refLinkFree(). */
struct refLink *refLinkLoad(char **row);

/** Load all refLink from a tab-separated file.
 * Dispose of this with refLinkFreeList(). */
struct refLink *refLinkLoadAll(char *fileName);

/** Create a refLink out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new refLink */
struct refLink *refLinkCommaIn(char **pS, struct refLink *ret);

/** Free a single dynamically allocated refLink such as created
 * with refLinkLoad(). */
void refLinkFree(struct refLink **pEl);

/** Free a list of dynamically allocated refLink's */
void refLinkFreeList(struct refLink **pList);

/** Print out refLink.  Separate fields with sep. Follow last field with lastSep. */
void refLinkOutput(struct refLink *el, FILE *f, char sep, char lastSep);

/** Print out refLink as a line in a tab-separated file. */
#define refLinkTabOut(el,f) refLinkOutput(el,f,'\t','\n');

/** Print out refLink as a comma separated list including final comma. */
#define refLinkCommaOut(el,f) refLinkOutput(el,f,',',',');

#endif /** REFLINK_H */

