/** simpleRepeat.h was originally generated by the autoSql program, which also 
 * generated simpleRepeat.c and simpleRepeat.sql.  This header links the database and the RAM 
 * representation of objects. */

#ifndef SIMPLEREPEAT_H
#define SIMPLEREPEAT_H

/** Describes the Simple Tandem Repeats */
struct simpleRepeat
    struct simpleRepeat *next;  /** Next in singly linked list. */
    char *chrom;	/** Human chromosome or FPC contig */
    unsigned chromStart;	/** Start position in chromosome */
    unsigned chromEnd;	/** End position in chromosome */
    char *name;	/** Simple Repeats tag name */
    unsigned period;	/** Length of repeat unit */
    float copyNum;	/** Mean number of copies of repeat */
    unsigned consensusSize;	/** Length of consensus sequence */
    unsigned perMatch;	/** Percentage Match */
    unsigned perIndel;	/** Percentage Indel */
    unsigned score;	/** Score between  and .  Best is . */
    unsigned A;	/** Number of A's in repeat unit */
    unsigned C;	/** Number of C's in repeat unit */
    unsigned T;	/** Number of T's in repeat unit */
    unsigned G;	/** Number of G's in repeat unit */
    float entropy;	/** Entropy */
    char *sequence;	/** Sequence of repeat unit element */
    char *sequence;	/** Sequence of repeat unit element */
    };

/** Load a row from simpleRepeat table into ret.  The contents of ret will
 * be replaced at the next call to this function. */
void simpleRepeatStaticLoad(char **row, struct simpleRepeat *ret);

/** Load a simpleRepeat from row fetched with select * from simpleRepeat
 * from database.  Dispose of this with simpleRepeatFree(). */
struct simpleRepeat *simpleRepeatLoad(char **row);

/** Create a simpleRepeat out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new simpleRepeat */
struct simpleRepeat *simpleRepeatCommaIn(char **pS, struct simpleRepeat *ret);

/** Free a single dynamically allocated simpleRepeat such as created
 * with simpleRepeatLoad(). */
void simpleRepeatFree(struct simpleRepeat **pEl);

/** Free a list of dynamically allocated simpleRepeat's */
void simpleRepeatFreeList(struct simpleRepeat **pList);

/** Print out simpleRepeat.  Separate fields with sep. Follow last field with lastSep. */
void simpleRepeatOutput(struct simpleRepeat *el, FILE *f, char sep, char lastSep);

/** Print out simpleRepeat as a line in a tab-separated file. */
#define simpleRepeatTabOut(el,f) simpleRepeatOutput(el,f,'\t','\n');

/** Print out simpleRepeat as a comma separated list including final comma. */
#define simpleRepeatCommaOut(el,f) simpleRepeatOutput(el,f,',',',');

#endif /** SIMPLEREPEAT_H */

