/** softberryHom.h was originally generated by the autoSql program, which also 
 * generated softberryHom.c and softberryHom.sql.  This header links the database and the RAM 
 * representation of objects. */

#ifndef SOFTBERRYHOM_H
#define SOFTBERRYHOM_H

/** Protein homologies behind Softberry genes */
struct softberryHom
    struct softberryHom *next;  /** Next in singly linked list. */
    char *name;	/** Softberry gene name */
    char *giString;	/** String with Genbank gi and accession */
    char *description;	/** Freeform (except for no tabs) description */
    char *description;	/** Freeform (except for no tabs) description */
    };

/** Load a row from softberryHom table into ret.  The contents of ret will
 * be replaced at the next call to this function. */
void softberryHomStaticLoad(char **row, struct softberryHom *ret);

/** Load a softberryHom from row fetched with select * from softberryHom
 * from database.  Dispose of this with softberryHomFree(). */
struct softberryHom *softberryHomLoad(char **row);

/** Create a softberryHom out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new softberryHom */
struct softberryHom *softberryHomCommaIn(char **pS, struct softberryHom *ret);

/** Free a single dynamically allocated softberryHom such as created
 * with softberryHomLoad(). */
void softberryHomFree(struct softberryHom **pEl);

/** Free a list of dynamically allocated softberryHom's */
void softberryHomFreeList(struct softberryHom **pList);

/** Print out softberryHom.  Separate fields with sep. Follow last field with lastSep. */
void softberryHomOutput(struct softberryHom *el, FILE *f, char sep, char lastSep);

/** Print out softberryHom as a line in a tab-separated file. */
#define softberryHomTabOut(el,f) softberryHomOutput(el,f,'\t','\n');

/** Print out softberryHom as a comma separated list including final comma. */
#define softberryHomCommaOut(el,f) softberryHomOutput(el,f,',',',');

#endif /** SOFTBERRYHOM_H */

