/** stsAlias.h was originally generated by the autoSql program, which also 
 * generated stsAlias.c and stsAlias.sql.  This header links the database and the RAM 
 * representation of objects. */

#ifndef STSALIAS_H
#define STSALIAS_H

/** List of aliases for STS files */
struct stsAlias
    struct stsAlias *next;  /** Next in singly linked list. */
    char *alias;	/** This specific alias */
    char *trueName;	/** True in our stsMarker table */
    char *trueName;	/** True in our stsMarker table */
    };

/** Load a row from stsAlias table into ret.  The contents of ret will
 * be replaced at the next call to this function. */
void stsAliasStaticLoad(char **row, struct stsAlias *ret);

/** Load a stsAlias from row fetched with select * from stsAlias
 * from database.  Dispose of this with stsAliasFree(). */
struct stsAlias *stsAliasLoad(char **row);

/** Create a stsAlias out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new stsAlias */
struct stsAlias *stsAliasCommaIn(char **pS, struct stsAlias *ret);

/** Free a single dynamically allocated stsAlias such as created
 * with stsAliasLoad(). */
void stsAliasFree(struct stsAlias **pEl);

/** Free a list of dynamically allocated stsAlias's */
void stsAliasFreeList(struct stsAlias **pList);

/** Print out stsAlias.  Separate fields with sep. Follow last field with lastSep. */
void stsAliasOutput(struct stsAlias *el, FILE *f, char sep, char lastSep);

/** Print out stsAlias as a line in a tab-separated file. */
#define stsAliasTabOut(el,f) stsAliasOutput(el,f,'\t','\n');

/** Print out stsAlias as a comma separated list including final comma. */
#define stsAliasCommaOut(el,f) stsAliasOutput(el,f,',',',');

#endif /** STSALIAS_H */

