/** browserTable.c was originally generated by the autoSql program, which also 
 * generated browserTable.h and browserTable.sql.  This module links the database and
 * the RAM representation of objects. */

#include "common.h"
#include "linefile.h"
#include "jksql.h"
#include "browserTable.h"

/** Load a row from browserTable table into ret.  The contents of ret will
 * be replaced at the next call to this function. */
void browserTableStaticLoad(char **row, struct browserTable *ret)
{
int sizeOne,i;
char *s;

strcpy(ret->tableName, row[0]);
strcpy(ret->longLabel, row[1]);
strcpy(ret->shortLabel, row[2]);
strcpy(ret->mapName, row[3]);
ret->version = row[4];
strcpy(ret->trackType, row[5]);
ret->visibility = sqlUnsigned(row[6]);
ret->colorR = sqlUnsigned(row[7]);
ret->colorG = sqlUnsigned(row[8]);
ret->colorB = sqlUnsigned(row[9]);
ret->altColorR = sqlUnsigned(row[10]);
ret->altColorG = sqlUnsigned(row[11]);
ret->altColorB = sqlUnsigned(row[12]);
ret->private = sqlUnsigned(row[13]);
ret->useScore = sqlUnsigned(row[14]);
ret->isSplit = sqlUnsigned(row[15]);
ret->priority = sqlSigned(row[16]);
ret->credit = row[17];
ret->url = row[18];
ret->other = row[19];
}

/** Load a browserTable from row fetched with select * from browserTable
 * from database.  Dispose of this with browserTableFree(). */
struct browserTable *browserTableLoad(char **row)
{
struct browserTable *ret;
int sizeOne,i;
char *s;

AllocVar(ret);
strcpy(ret->tableName, row[0]);
strcpy(ret->longLabel, row[1]);
strcpy(ret->shortLabel, row[2]);
strcpy(ret->mapName, row[3]);
ret->version = cloneString(row[4]);
strcpy(ret->trackType, row[5]);
ret->visibility = sqlUnsigned(row[6]);
ret->colorR = sqlUnsigned(row[7]);
ret->colorG = sqlUnsigned(row[8]);
ret->colorB = sqlUnsigned(row[9]);
ret->altColorR = sqlUnsigned(row[10]);
ret->altColorG = sqlUnsigned(row[11]);
ret->altColorB = sqlUnsigned(row[12]);
ret->private = sqlUnsigned(row[13]);
ret->useScore = sqlUnsigned(row[14]);
ret->isSplit = sqlUnsigned(row[15]);
ret->priority = sqlSigned(row[16]);
ret->credit = cloneString(row[17]);
ret->url = cloneString(row[18]);
ret->other = cloneString(row[19]);
return ret;
}

/** Load all browserTable from a tab-separated file.
 * Dispose of this with browserTableFreeList(). */
struct browserTable *browserTableLoadAll(char *fileName) 
{
struct browserTable *list = NULL, *el;
struct lineFile *lf = lineFileOpen(fileName, TRUE);
char *row[20];

while (lineFileRow(lf, row))
    {
    el = browserTableLoad(row);
    slAddHead(&list, el);
    }
lineFileClose(&lf);
slReverse(&list);
return list;
}

/** Create a browserTable out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new browserTable */
struct browserTable *browserTableCommaIn(char **pS, struct browserTable *ret)
{
char *s = *pS;
int i;

if (ret == NULL)
    AllocVar(ret);
sqlFixedStringComma(&s, ret->tableName, sizeof(ret->tableName));
sqlFixedStringComma(&s, ret->longLabel, sizeof(ret->longLabel));
sqlFixedStringComma(&s, ret->shortLabel, sizeof(ret->shortLabel));
sqlFixedStringComma(&s, ret->mapName, sizeof(ret->mapName));
ret->version = sqlStringComma(&s);
sqlFixedStringComma(&s, ret->trackType, sizeof(ret->trackType));
ret->visibility = sqlUnsignedComma(&s);
ret->colorR = sqlUnsignedComma(&s);
ret->colorG = sqlUnsignedComma(&s);
ret->colorB = sqlUnsignedComma(&s);
ret->altColorR = sqlUnsignedComma(&s);
ret->altColorG = sqlUnsignedComma(&s);
ret->altColorB = sqlUnsignedComma(&s);
ret->private = sqlUnsignedComma(&s);
ret->useScore = sqlUnsignedComma(&s);
ret->isSplit = sqlUnsignedComma(&s);
ret->priority = sqlSignedComma(&s);
ret->credit = sqlStringComma(&s);
ret->url = sqlStringComma(&s);
ret->other = sqlStringComma(&s);
*pS = s;
return ret;
}

/** Free a single dynamically allocated browserTable such as created
 * with browserTableLoad(). */
void browserTableFree(struct browserTable **pEl)
{
struct browserTable *el;

if ((el = *pEl) == NULL) return;
freeMem(el->version);
freeMem(el->credit);
freeMem(el->url);
freeMem(el->other);
freez(pEl);
}

/** Free a list of dynamically allocated browserTable's */
void browserTableFreeList(struct browserTable **pList)
{
struct browserTable *el, *next;

for (el = *pList; el != NULL; el = next)
    {
    next = el->next;
    browserTableFree(&el);
    }
*pList = NULL;
}

/** Print out browserTable.  Separate fields with sep. Follow last field with lastSep. */
void browserTableOutput(struct browserTable *el, FILE *f, char sep, char lastSep) 
{
int i;
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->tableName);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->longLabel);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->shortLabel);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->mapName);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->version);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->trackType);
if (sep == ',') fputc('"',f);
fputc(sep,f);
fprintf(f, "%u", el->visibility);
fputc(sep,f);
fprintf(f, "%u", el->colorR);
fputc(sep,f);
fprintf(f, "%u", el->colorG);
fputc(sep,f);
fprintf(f, "%u", el->colorB);
fputc(sep,f);
fprintf(f, "%u", el->altColorR);
fputc(sep,f);
fprintf(f, "%u", el->altColorG);
fputc(sep,f);
fprintf(f, "%u", el->altColorB);
fputc(sep,f);
fprintf(f, "%u", el->private);
fputc(sep,f);
fprintf(f, "%u", el->useScore);
fputc(sep,f);
fprintf(f, "%u", el->isSplit);
fputc(sep,f);
fprintf(f, "%d", el->priority);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->credit);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->url);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->other);
if (sep == ',') fputc('"',f);
fputc(lastSep,f);
}

