/** chromInfo.c was originally generated by the autoSql program, which also 
 * generated chromInfo.h and chromInfo.sql.  This module links the database and the RAM 
 * representation of objects. */

#include "common.h"
#include "jksql.h"
#include "chromInfo.h"

/** Load a row from chromInfo table into ret.  The contents of ret will
 * be replaced at the next call to this function. */
void chromInfoStaticLoad(char **row, struct chromInfo *ret)
{
int sizeOne,i;
char *s;

ret->chrom = row[0];
ret->size = sqlUnsigned(row[1]);
ret->fileName = row[2];
}

/** Load a chromInfo from row fetched with select * from chromInfo
 * from database.  Dispose of this with chromInfoFree(). */
struct chromInfo *chromInfoLoad(char **row)
{
struct chromInfo *ret;
int sizeOne,i;
char *s;

AllocVar(ret);
ret->chrom = cloneString(row[0]);
ret->size = sqlUnsigned(row[1]);
ret->fileName = cloneString(row[2]);
return ret;
}

/** Create a chromInfo out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new chromInfo */
struct chromInfo *chromInfoCommaIn(char **pS, struct chromInfo *ret)
{
char *s = *pS;
int i;

if (ret == NULL)
    AllocVar(ret);
ret->chrom = sqlStringComma(&s);
ret->size = sqlUnsignedComma(&s);
ret->fileName = sqlStringComma(&s);
*pS = s;
return ret;
}

/** Free a single dynamically allocated chromInfo such as created
 * with chromInfoLoad(). */
void chromInfoFree(struct chromInfo **pEl)
{
struct chromInfo *el;

if ((el = *pEl) == NULL) return;
freeMem(el->chrom);
freeMem(el->fileName);
freez(pEl);
}

/** Free a list of dynamically allocated chromInfo's */
void chromInfoFreeList(struct chromInfo **pList)
{
struct chromInfo *el, *next;

for (el = *pList; el != NULL; el = next)
    {
    next = el->next;
    chromInfoFree(&el);
    }
*pList = NULL;
}

/** Print out chromInfo.  Separate fields with sep. Follow last field with lastSep. */
void chromInfoOutput(struct chromInfo *el, FILE *f, char sep, char lastSep) 
{
int i;
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->chrom);
if (sep == ',') fputc('"',f);
fputc(sep,f);
fprintf(f, "%u", el->size);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->fileName);
if (sep == ',') fputc('"',f);
fputc(lastSep,f);
}

