/** clonePos.c was originally generated by the autoSql program, which also 
 * generated clonePos.h and clonePos.sql.  This module links the database and the RAM 
 * representation of objects. */

#include "common.h"
#include "jksql.h"
#include "clonePos.h"

/** Load a row from clonePos table into ret.  The contents of ret will
 * be replaced at the next call to this function. */
void clonePosStaticLoad(char **row, struct clonePos *ret)
{
int sizeOne,i;
char *s;

ret->name = row[0];
ret->seqSize = sqlUnsigned(row[1]);
ret->phase = sqlUnsigned(row[2]);
ret->chrom = row[3];
ret->chromStart = sqlUnsigned(row[4]);
ret->chromEnd = sqlUnsigned(row[5]);
strcpy(ret->stage, row[6]);
ret->faFile = row[7];
}

/** Load a clonePos from row fetched with select * from clonePos
 * from database.  Dispose of this with clonePosFree(). */
struct clonePos *clonePosLoad(char **row)
{
struct clonePos *ret;
int sizeOne,i;
char *s;

AllocVar(ret);
ret->name = cloneString(row[0]);
ret->seqSize = sqlUnsigned(row[1]);
ret->phase = sqlUnsigned(row[2]);
ret->chrom = cloneString(row[3]);
ret->chromStart = sqlUnsigned(row[4]);
ret->chromEnd = sqlUnsigned(row[5]);
strcpy(ret->stage, row[6]);
ret->faFile = cloneString(row[7]);
return ret;
}

/** Create a clonePos out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new clonePos */
struct clonePos *clonePosCommaIn(char **pS, struct clonePos *ret)
{
char *s = *pS;
int i;

if (ret == NULL)
    AllocVar(ret);
ret->name = sqlStringComma(&s);
ret->seqSize = sqlUnsignedComma(&s);
ret->phase = sqlUnsignedComma(&s);
ret->chrom = sqlStringComma(&s);
ret->chromStart = sqlUnsignedComma(&s);
ret->chromEnd = sqlUnsignedComma(&s);
sqlFixedStringComma(&s, ret->stage, sizeof(ret->stage));
ret->faFile = sqlStringComma(&s);
*pS = s;
return ret;
}

/** Free a single dynamically allocated clonePos such as created
 * with clonePosLoad(). */
void clonePosFree(struct clonePos **pEl)
{
struct clonePos *el;

if ((el = *pEl) == NULL) return;
freeMem(el->name);
freeMem(el->chrom);
freeMem(el->faFile);
freez(pEl);
}

/** Free a list of dynamically allocated clonePos's */
void clonePosFreeList(struct clonePos **pList)
{
struct clonePos *el, *next;

for (el = *pList; el != NULL; el = next)
    {
    next = el->next;
    clonePosFree(&el);
    }
*pList = NULL;
}

/** Print out clonePos.  Separate fields with sep. Follow last field with lastSep. */
void clonePosOutput(struct clonePos *el, FILE *f, char sep, char lastSep) 
{
int i;
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->name);
if (sep == ',') fputc('"',f);
fputc(sep,f);
fprintf(f, "%u", el->seqSize);
fputc(sep,f);
fprintf(f, "%u", el->phase);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->chrom);
if (sep == ',') fputc('"',f);
fputc(sep,f);
fprintf(f, "%u", el->chromStart);
fputc(sep,f);
fprintf(f, "%u", el->chromEnd);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->stage);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->faFile);
if (sep == ',') fputc('"',f);
fputc(lastSep,f);
}

