/** ctgPos.c was originally generated by the autoSql program, which also 
 * generated ctgPos.h and ctgPos.sql.  This module links the database and the RAM 
 * representation of objects. */

#include "common.h"
#include "jksql.h"
#include "ctgPos.h"

/** Load a row from ctgPos table into ret.  The contents of ret will
 * be replaced at the next call to this function. */
void ctgPosStaticLoad(char **row, struct ctgPos *ret)
{
int sizeOne,i;
char *s;

ret->contig = row[0];
ret->size = sqlUnsigned(row[1]);
ret->chrom = row[2];
ret->chromStart = sqlUnsigned(row[3]);
ret->chromEnd = sqlUnsigned(row[4]);
}

/** Load a ctgPos from row fetched with select * from ctgPos
 * from database.  Dispose of this with ctgPosFree(). */
struct ctgPos *ctgPosLoad(char **row)
{
struct ctgPos *ret;
int sizeOne,i;
char *s;

AllocVar(ret);
ret->contig = cloneString(row[0]);
ret->size = sqlUnsigned(row[1]);
ret->chrom = cloneString(row[2]);
ret->chromStart = sqlUnsigned(row[3]);
ret->chromEnd = sqlUnsigned(row[4]);
return ret;
}

/** Create a ctgPos out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new ctgPos */
struct ctgPos *ctgPosCommaIn(char **pS, struct ctgPos *ret)
{
char *s = *pS;
int i;

if (ret == NULL)
    AllocVar(ret);
ret->contig = sqlStringComma(&s);
ret->size = sqlUnsignedComma(&s);
ret->chrom = sqlStringComma(&s);
ret->chromStart = sqlUnsignedComma(&s);
ret->chromEnd = sqlUnsignedComma(&s);
*pS = s;
return ret;
}

/** Free a single dynamically allocated ctgPos such as created
 * with ctgPosLoad(). */
void ctgPosFree(struct ctgPos **pEl)
{
struct ctgPos *el;

if ((el = *pEl) == NULL) return;
freeMem(el->contig);
freeMem(el->chrom);
freez(pEl);
}

/** Free a list of dynamically allocated ctgPos's */
void ctgPosFreeList(struct ctgPos **pList)
{
struct ctgPos *el, *next;

for (el = *pList; el != NULL; el = next)
    {
    next = el->next;
    ctgPosFree(&el);
    }
*pList = NULL;
}

/** Print out ctgPos.  Separate fields with sep. Follow last field with lastSep. */
void ctgPosOutput(struct ctgPos *el, FILE *f, char sep, char lastSep) 
{
int i;
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->contig);
if (sep == ',') fputc('"',f);
fputc(sep,f);
fprintf(f, "%u", el->size);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->chrom);
if (sep == ',') fputc('"',f);
fputc(sep,f);
fprintf(f, "%u", el->chromStart);
fputc(sep,f);
fprintf(f, "%u", el->chromEnd);
fputc(lastSep,f);
}

