/** pepPred.c was originally generated by the autoSql program, which also 
 * generated pepPred.h and pepPred.sql.  This module links the database and the RAM 
 * representation of objects. */

#include "common.h"
#include "jksql.h"
#include "pepPred.h"

/** Load a row from pepPred table into ret.  The contents of ret will
 * be replaced at the next call to this function. */
void pepPredStaticLoad(char **row, struct pepPred *ret)
{
int sizeOne,i;
char *s;

ret->name = row[0];
ret->seq = row[1];
}

/** Load a pepPred from row fetched with select * from pepPred
 * from database.  Dispose of this with pepPredFree(). */
struct pepPred *pepPredLoad(char **row)
{
struct pepPred *ret;
int sizeOne,i;
char *s;

AllocVar(ret);
ret->name = cloneString(row[0]);
ret->seq = cloneString(row[1]);
return ret;
}

/** Create a pepPred out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new pepPred */
struct pepPred *pepPredCommaIn(char **pS, struct pepPred *ret)
{
char *s = *pS;
int i;

if (ret == NULL)
    AllocVar(ret);
ret->name = sqlStringComma(&s);
ret->seq = sqlStringComma(&s);
*pS = s;
return ret;
}

/** Free a single dynamically allocated pepPred such as created
 * with pepPredLoad(). */
void pepPredFree(struct pepPred **pEl)
{
struct pepPred *el;

if ((el = *pEl) == NULL) return;
freeMem(el->name);
freeMem(el->seq);
freez(pEl);
}

/** Free a list of dynamically allocated pepPred's */
void pepPredFreeList(struct pepPred **pList)
{
struct pepPred *el, *next;

for (el = *pList; el != NULL; el = next)
    {
    next = el->next;
    pepPredFree(&el);
    }
*pList = NULL;
}

/** Print out pepPred.  Separate fields with sep. Follow last field with lastSep. */
void pepPredOutput(struct pepPred *el, FILE *f, char sep, char lastSep) 
{
int i;
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->name);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->seq);
if (sep == ',') fputc('"',f);
fputc(lastSep,f);
}

