/** qaToQac - convert from uncompressed to compressed 
 * quality score format. */
#include "common.h"
#include "linefile.h"
#include "qaSeq.h"

/** Explain usage and exit. */
void usage()
{
errAbort(
"qaToQac - convert from uncompressed to compressed\n"
"quality score format.\n"
"usage:\n"
"   qaToQac in.qa out.qac");
}

/** qaToQac - convert from uncompressed to compressed 
 * quality score format. */
void qaToQac(char *inName, char *outName)
{
struct lineFile *lf = lineFileOpen(inName, TRUE);
FILE *f = mustOpen(outName, "wb");
struct qaSeq *qa;

qacWriteHead(f);
while ((qa = qaReadNext(lf)) != NULL)
    {
    qacWriteNext(f, qa);
    qaSeqFree(&qa);
    }
lineFileClose(&lf);
fclose(f);
}

/** Process command line. */
int main(int argc, char *argv[])
{
if (argc < 2)
    usage();
qaToQac(argv[1], argv[2]);
}
