/*** bits - handle operations on arrays of bits. */

typedef unsigned char Bits;

/*** Allocate bits. */
Bits *bitAlloc(int bitCount);

/*** Free bits. */
void bitFree(Bits **pB);

/*** Set a single bit. */
void bitSetOne(Bits *b, int bitIx);

/*** Set a range of bits. */
void bitSetRange(Bits *b, int startIx, int bitCount);

boolean bitReadOne(Bits *b, int bitIx);
/*** Read a single bit. */

/*** Count number of bits set in range. */
int bitCountRange(Bits *b, int startIx, int bitCount);

