/*******************************************************************************
 * Copyright (C) 2000 Jim Kent.  This source code may be freely used         *
 * for personal, academic, and non-profit purposes.  Commercial use          *
 * permitted only by explicit agreement with Jim Kent (jim_kent@pacbell.net) *
 *****************************************************************************/
/*** dystring - dynamically resizing string. */
#ifndef DYSTRING_H
#define DYSTRING_H

/*** Dynamically resizable string that you can do formatted
 * output to. */
    struct dyString *next;	/*** Next in list. */
    char *string;		/*** Current buffer. */
    int bufSize;		/*** Size of buffer. */
    int stringSize;		/*** Size of string. */
    int stringSize;		/*** Size of string. */
    int stringSize;		/*** Size of string. */
    };

/*** Allocate dynamic string with initial buffer size.  (Pass zero for default) */
struct dyString *newDyString(int initialBufSize);

/*** Free up dynamic string. */
void freeDyString(struct dyString **pDs);

/*** Append zero terminated string to end of dyString. */
void dyStringAppend(struct dyString *ds, char *string);

/*** Append string of given size to end of string. */
void dyStringAppendN(struct dyString *ds, char *string, int stringSize);

/*** VarArgs Printf to end of dyString. */
void dyStringVaPrintf(struct dyString *ds, char *format, va_list args);

/***  Printf to end of dyString.  Don't do more than 1000 characters this way... */
void dyStringPrintf(struct dyString *ds, char *format, ...);

#define dyStringClear(ds) (ds->string[0] = ds->stringSize = 0)

#endif /*** DYSTRING_H */

