/*** seqOut - stuff to output sequences and alignments in web 
 * or ascii viewable form. */

/*** Colored web character output formatter. */
    int wordLen;	/*** Number of characters between spaces (often 10) */
    int lineLen;        /*** Number of characters between lines (often 50) */
    int inWord, inLine; /*** Position in word and line. */
    bool lineNumbers;   /*** True if write position at end of line. */
    bool countDown;     /*** True if want numbers counting down. */
    int lastColor;      /*** Cache last color here. */
    long charCount;     /*** Number of characters written total. */
    FILE *out;          /*** File to write to. */
    int numOff;         /*** Number to start with. */
    int numOff;         /*** Number to start with. */
    int numOff;         /*** Number to start with. */
    };

void cfmInit(struct cfm *cfm, int wordLen, int lineLen, 
	boolean lineNumbers, boolean countDown, FILE *out, int numOff);
/*** Set up colored sequence formatting for html. */

/*** Write out a byte, and depending on color formatting extras  */
void cfmOut(struct cfm *cfm, char c, int color);

/*** Finish up cfm formatting job. */
void cfmCleanup(struct cfm *cfm);

enum seqOutColor
/*** Symbolic color for sequence output. */
    socBlue = 1,		/*** Aligning. */
    socBrightBlue = 2,		/*** End of an aligning block. */
    socBrightBlue = 2,		/*** End of an aligning block. */
extern int seqOutColorLookup[];		/*** Converts these to html format colors. */
extern int seqOutColorLookup[];		/*** Converts these to html format colors. */
extern int seqOutColorLookup[];		/*** Converts these to html format colors. */

/*** Block allignment formatter. */
struct baf
    {
    char nChars[256];
    char hChars[256];
    int cix;
    int nLineStart;
    int hLineStart;
    int nCurPos;
    int hCurPos;
    DNA *needle, *haystack;
    int nNumOff, hNumOff;
    bool hCountDown;     /*** True if want numbers counting down. */
    bool isTrans;	 /*** True if haystack is translated. */
    bool nCountDown;	 /*** True if want needle numbers counting down. */
    bool nCountDown;	 /*** True if want needle numbers counting down. */
    bool nCountDown;	 /*** True if want needle numbers counting down. */
    };

void bafInit(struct baf *baf, DNA *needle, int nNumOff, boolean nCountDown,
	DNA *haystack, int hNumOff, boolean hCountDown, 
	FILE *out, int lineSize, boolean isTrans);
/*** Initialize block alignment formatter. */

/*** Set up block formatter around an ffAli block. */
void bafSetAli(struct baf *baf, struct ffAli *ali);

/*** Set up block formatter starting at nStart/hStart. */
void bafSetPos(struct baf *baf, int nStart, int hStart);

/*** Set up block formatter to start new line at current position. */
void bafStartLine(struct baf *baf);

/*** Write out a line of an alignment (which takes up
 * three lines on the screen. */
void bafWriteLine(struct baf *baf);

/*** Write a pair of character to block alignment. */
void bafOut(struct baf *baf, char n, char h);

/*** Write out alignment line if it has any characters in it. */
void bafFlushLine(struct baf *baf);

