/*******************************************************************************
 * Copyright (C) 2000 Jim Kent.  This source code may be freely used         *
 * for personal, academic, and non-profit purposes.  Commercial use          *
 * permitted only by explicit agreement with Jim Kent (jim_kent@pacbell.net) *
 *****************************************************************************/
/*** Shared Resource file */
#ifndef SHARES_H
#define SHARES_H

/*** A shared resource node. */
struct shaResNode
    {
    struct shaResNode *next;
    struct shaResNode *prev;
    int links;
    char *name;
    struct shaResList *list;
    void *data;
    };

/*** A shared resource list. */
struct shaResList
    {
    struct shaResNode *head;
    void (*freeData)(void *pData);
    };


/*** Decrement link count and free if down to zero. */
void shaUnlink(struct shaResNode *node);

/*** Increment link count. */
void shaLink(struct shaResNode *node);

/*** Create a new node with link count of one. */
struct shaResNode *shaNewNode(struct shaResList *list, char *name, void *data);

/*** Free every node on list. */
void shaCleanup(struct shaResList *list);

/*** Start up resource list. */
#endif /** SHARES_H */
void shaInit(struct shaResList *list, void (*freeData)(void *pData));



