/*** sqlNum.h - routines to convert from ascii to
 * unsigned/integer a bit more quickly than atoi. */
#ifndef SQLNUM_H
#define SQLNUM_H

/*** Convert series of digits to unsigned integer about
 * twice as fast as atoi (by not having to skip white 
 * space or stop except at the null byte.) */
unsigned sqlUnsigned(char *s);

/*** Convert string to signed integer.  Unlike atol assumes 
 * all of string is number. */
int sqlSigned(char *s);


#endif /*** SQLNUM_H */
 
