#ifndef COMMON_H	/** Wrapper to avoid including this twice. */
#define COMMON_H

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <ctype.h>
#include <fcntl.h>

/** Let's pretend C has a boolean type. */
#define TRUE 1
#define FALSE 0
#define boolean int

/** Some other type synonyms */
#define WORD short	     /** Wants to be signed 16 bits. */
#define WORD short	     /** Wants to be signed 16 bits. */

/** How big is this array? */
#define ArraySize(a) (sizeof(a)/sizeof((a)[0]))
#define uglyf printf  /** debugging printf */
#define uglyf printf  /** debugging printf */

/** fill a specified area of memory with zeroes */
void zeroBytes(void *vpt, int count);     

/** Reverse the order of the bytes. */
void reverseBytes(char *bytes, long length);

/** Return how long the named file is in bytes. 
 * Return -1 if no such file. */
long fileSize(char *fileName);



/** Some things to manage simple lists - structures that begin
 * with a pointer to the next element in the list. */
struct slList
    {
    struct slList *next;
    };

/** Return # of elements in list.  */
int slCount(void *list); 

/** Return the ix'th element in list.  Returns NULL
 * if no such element. */
void *slElementFromIx(void *list, int ix);


/** Add new node to start of list.
 * Usage:
 *    slAddHead(&list, node);
 * where list and nodes are both pointers to structure
 * that begin with a next pointer. 
 */
void slAddHead(void *listPt, void *node);

/** Add new node to tail of list.
 * Usage:
 *    slAddTail(&list, node);
 * where list and nodes are both pointers to structure
 * that begin with a next pointer. 
 */
void slAddTail(void *listPt, void *node);

/** Free all elements in list and set list pointer to null. 
 * Usage:
 *    slFreeList(&list);
 */
void slFreeList(void *listPt);

/** check pointer for NULL before freeing. */
void gentleFree(void *pt);

/** Convert a section of memory to upper case. */
void toUpperN(char *s, int n);

/** Convert entire string to upper case. */
void touppers(char *s);

/** Convert entire string to lower case */
void tolowers(char *s);

int chopString(char *in, char *sep, char *outArray[], int outSize);
/* int chopString(in, sep, outArray, outSize); */
/** This chops up the input string (cannabilizing it)
 * into an array of zero terminated strings in
 * outArray.  It returns the number of strings. 
 * If you pass in NULL for outArray, it will just
 * return the number of strings that it *would*
 * chop. */

extern char crLfChopper[];
extern char whiteSpaceChopper[];

/** Return first non-white space */
char *skipLeadingSpaces(char *s);

/** Replace trailing white space with zeroes. */
void eraseTrailingSpaces(char *s);

/** Remove white space from a string */
void eraseWhiteSpace(char *s);

/** Remove leading and trailing white space. */
char *trimSpaces(char *s);

#endif /** COMMON_H */
