/** addCols - Add together columns. */
#include "common.h"
#include "linefile.h"

/** Explain usage and exit. */
void usage()
{
errAbort(
  "addCols - Add together columns\n"
  "usage:\n"
  "   addCols XXX\n");
}

/** addCols - Add together columns. */
void addCols(char *fileName)
{
struct lineFile *lf;
char *words[16];
int wordCount;
static double totals[16];
int maxCount = 0;
int i;

if (sameString(fileName, "stdin"))
    lf = lineFileStdin(TRUE);
else
    lf = lineFileOpen(fileName, TRUE);
for (i=0; i<ArraySize(words); ++i)
     totals[i] = 0;
while ((wordCount = lineFileChop(lf, words)) != 0)
    {
    if (maxCount < wordCount)
        maxCount = wordCount;
    for (i=0; i<wordCount; ++i)
        totals[i] += atof(words[i]);
    }
for (i=0; i<maxCount; ++i)
     printf("%6.2f ", totals[i]);
printf("\n");
}

/** Process command line. */
int main(int argc, char *argv[])
{
if (argc != 2)
    usage();
addCols(argv[1]);
return 0;
}
