/** catUncomment - Concatenate input removing lines that start with '#'. */
#include "common.h"
#include "linefile.h"

/** Explain usage and exit. */
void usage()
{
errAbort(
  "catUncomment - Concatenate input removing lines that start with '#'\n"
  "Output goes to stdout\n"
  "usage:\n"
  "   catUncomment file(s)\n");
}

/** catUncomment - Concatenate input removing lines that start with '#'. */
void catUncomment(int inCount, char *inNames[])
{
struct lineFile *lf;
char *fileName;
char *line;
int i, lineSize;

for (i=0; i<inCount; ++i)
    {
    fileName =  inNames[i];
    lf = lineFileOpen(fileName, FALSE);
    while (lineFileNext(lf, &line, &lineSize))
        {
	if (line[0] != '#')
	    mustWrite(stdout, line, lineSize);
	}
    lineFileClose(&lf);
    }
}

/** Process command line. */
int main(int argc, char *argv[])
{
if (argc < 2)
    usage();
catUncomment(argc-1, argv+1);
return 0;
}
