/** faOneRecord - Extract a single record from a .FA file. */
#include "common.h"
#include "linefile.h"

/** Explain usage and exit. */
void usage()
{
errAbort(
  "faOneRecord - Extract a single record from a .FA file\n"
  "usage:\n"
  "   faOneRecord in.fa recordName\n");
}

/** faOneRecord - Extract a single record from a .FA file. */
void faOneRecord(char *fileName, char *recordName)
{
FILE *f = mustOpen(fileName, "r");
struct lineFile *lf = lineFileOpen(fileName, FALSE);
int lineSize;
char *line;
boolean inRecord = FALSE;

while (lineFileNext(lf, &line, &lineSize))
    {
    if (line[0] == '>')
	inRecord =  startsWith(recordName, line+1);
    if (inRecord)
        mustWrite(stdout, line, lineSize);
    }
}

/** Process command line. */
int main(int argc, char *argv[])
{
if (argc != 3)
    usage();
faOneRecord(argv[1], argv[2]);
return 0;
}
