/** faToNib - Convert from .fa to .nib format. */
#include "common.h"
#include "nib.h"
#include "fa.h"

/** Explain usage and exit. */
void usage()
{
errAbort(
  "faToNib - Convert from .fa to .nib format\n"
  "usage:\n"
  "   faToNib in.fa out.nib\n");
}

/** faToNib - Convert from .fa to .nib format. */
void faToNib(char *in, char *out)
{
struct dnaSeq *seq = faReadDna(in);
nibWrite(seq, out);
}

/** Process command line. */
int main(int argc, char *argv[])
{
if (argc != 3)
    usage();
faToNib(argv[1], argv[2]);
return 0;
}
