/** ScrambleFa - scramble the order of records in an fa file. */
#include "common.h"
#include "fa.h"

/** scrambleFa - scramble the order of records in an fa file. */
void scrambleFa(char *inName, char *outName)
{
struct dnaSeq *seqList, *seq;
int seqCount;
int seqIx;
FILE *out;

seqList = faReadAllDna(inName);
out = mustOpen(outName, "w");
seqCount = slCount(seqList);
while (seqCount > 0)
    {
    seqIx = rand()%seqCount;
    seq = slElementFromIx(seqList, seqIx);
    faWriteNext(out, seq->name, seq->dna, seq->size);
    slRemoveEl(&seqList, seq);
    --seqCount;
    }
fclose(out);
}

/** Explain usage and exit. */
void usage()
{
errAbort("scrambleFa - scramble the order of records in an fa file\n"
         "usage:\n"
	 "    scrambleFa in.fa out.fa");
}

/** Process command line. */
int main(int argc, char *argv[])
{
if (argc != 3)
    usage();
scrambleFa(argv[1], argv[2]);
}
