/** toLower - Convert upper case to lower case in file. Leave other chars alone. */
#include "common.h"
#include "linefile.h"

/** Explain usage and exit. */
void usage()
{
errAbort(
  "toLower - Convert upper case to lower case in file. Leave other chars alone\n"
  "usage:\n"
  "   toLower in out\n");
}

/** toLower - Convert upper case to lower case in file. Leave other chars alone. */
void toLower(char *inName, char *outName)
{
struct lineFile *lf = lineFileOpen(inName, FALSE);
FILE *f = mustOpen(outName, "w");
int lineSize;
char *line;

while (lineFileNext(lf, &line, &lineSize))
    {
    toLowerN(line, lineSize);
    mustWrite(f, line, lineSize);
    }
fclose(f);
}

/** Process command line. */
int main(int argc, char *argv[])
{
if (argc != 3)
    usage();
toLower(argv[1], argv[2]);
return 0;
}
