/** wabaCrude.c was originally generated by the autoSql program, which also 
 * generated wabaCrude.h and wabaCrude.sql.  This module links the database and the RAM 
 * representation of objects. */

#include "common.h"
#include "wabaCrude.h"

#define sqlUnsigned atoi
#define sqlSigned atoi

/** Load a row from wabaCrude table into ret.  The contents of ret will
 * be replaced at the next call to this function. */
void wabaCrudeStaticLoad(char **row, struct wabaCrude *ret)
{
int sizeOne,i;
char *s;

ret->score = sqlUnsigned(row[0]);
ret->qFile = row[1];
ret->qSeq = row[2];
ret->qStart = sqlUnsigned(row[3]);
ret->qEnd = sqlUnsigned(row[4]);
ret->strand = sqlSigned(row[5]);
ret->tFile = row[6];
ret->tSeq = row[7];
ret->tStart = sqlUnsigned(row[8]);
ret->tEnd = sqlUnsigned(row[9]);
}

/** Load a wabaCrude from row fetched with select * from wabaCrude
 * from database.  Dispose of this with wabaCrudeFree(). */
struct wabaCrude *wabaCrudeLoad(char **row)
{
struct wabaCrude *ret;
int sizeOne,i;
char *s;

AllocVar(ret);
ret->score = sqlUnsigned(row[0]);
ret->qFile = cloneString(row[1]);
ret->qSeq = cloneString(row[2]);
ret->qStart = sqlUnsigned(row[3]);
ret->qEnd = sqlUnsigned(row[4]);
ret->strand = sqlSigned(row[5]);
ret->tFile = cloneString(row[6]);
ret->tSeq = cloneString(row[7]);
ret->tStart = sqlUnsigned(row[8]);
ret->tEnd = sqlUnsigned(row[9]);
return ret;
}

/** Free a single dynamically allocated wabaCrude such as created
 * with wabaCrudeLoad(). */
void wabaCrudeFree(struct wabaCrude **pEl)
{
struct wabaCrude *el;

if ((el = *pEl) == NULL) return;
freeMem(el->qFile);
freeMem(el->qSeq);
freeMem(el->tFile);
freeMem(el->tSeq);
freez(pEl);
}

/** Free a list of dynamically allocated wabaCrude's */
void wabaCrudeFreeList(struct wabaCrude **pList)
{
struct wabaCrude *el, *next;

for (el = *pList; el != NULL; el = next)
    {
    next = el->next;
    wabaCrudeFree(&el);
    }
*pList = NULL;
}

/** Print out wabaCrude.  Separate fields with sep. Follow last field with lastSep. */
void wabaCrudeOutput(struct wabaCrude *el, FILE *f, char sep, char lastSep) 
{
int i;
fprintf(f, "%u", el->score, sep);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->qFile, sep);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->qSeq, sep);
if (sep == ',') fputc('"',f);
fputc(sep,f);
fprintf(f, "%u", el->qStart, sep);
fputc(sep,f);
fprintf(f, "%u", el->qEnd, sep);
fputc(sep,f);
fprintf(f, "%d", el->strand, sep);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->tFile, sep);
if (sep == ',') fputc('"',f);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->tSeq, sep);
if (sep == ',') fputc('"',f);
fputc(sep,f);
fprintf(f, "%u", el->tStart, sep);
fputc(sep,f);
fprintf(f, "%u", el->tEnd, lastSep);
fputc(lastSep,f);
}

