/** snp.c was originally generated by the autoSql program, which also 
 * generated snp.h and snp.sql.  This module links the database and the RAM 
 * representation of objects. */

#include "common.h"
#include "jksql.h"
#include "snp.h"

/** Load a row from snp table into ret.  The contents of ret will
 * be replaced at the next call to this function. */
void snpStaticLoad(char **row, struct snp *ret)
{
int sizeOne,i;
char *s;

ret->chrom = row[0];
ret->chromStart = sqlUnsigned(row[1]);
ret->chromEnd = sqlUnsigned(row[2]);
ret->name = row[3];
}

/** Load a snp from row fetched with select * from snp
 * from database.  Dispose of this with snpFree(). */
struct snp *snpLoad(char **row)
{
struct snp *ret;
int sizeOne,i;
char *s;

AllocVar(ret);
ret->chrom = cloneString(row[0]);
ret->chromStart = sqlUnsigned(row[1]);
ret->chromEnd = sqlUnsigned(row[2]);
ret->name = cloneString(row[3]);
return ret;
}

/** Create a snp out of a comma separated string. 
 * This will fill in ret if non-null, otherwise will
 * return a new snp */
struct snp *snpCommaIn(char **pS, struct snp *ret)
{
char *s = *pS;
int i;

if (ret == NULL)
    AllocVar(ret);
ret->chrom = sqlStringComma(&s);
ret->chromStart = sqlUnsignedComma(&s);
ret->chromEnd = sqlUnsignedComma(&s);
ret->name = sqlStringComma(&s);
*pS = s;
return ret;
}

/** Free a single dynamically allocated snp such as created
 * with snpLoad(). */
void snpFree(struct snp **pEl)
{
struct snp *el;

if ((el = *pEl) == NULL) return;
freeMem(el->chrom);
freeMem(el->name);
freez(pEl);
}

/** Free a list of dynamically allocated snp's */
void snpFreeList(struct snp **pList)
{
struct snp *el, *next;

for (el = *pList; el != NULL; el = next)
    {
    next = el->next;
    snpFree(&el);
    }
*pList = NULL;
}

/** Print out snp.  Separate fields with sep. Follow last field with lastSep. */
void snpOutput(struct snp *el, FILE *f, char sep, char lastSep) 
{
int i;
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->chrom);
if (sep == ',') fputc('"',f);
fputc(sep,f);
fprintf(f, "%u", el->chromStart);
fputc(sep,f);
fprintf(f, "%u", el->chromEnd);
fputc(sep,f);
if (sep == ',') fputc('"',f);
fprintf(f, "%s", el->name);
if (sep == ',') fputc('"',f);
fputc(lastSep,f);
}

